PT-SLAVE-FIND(1p)

NAME
pt-slave-find - Find and print replication hierarchy tree of MySQL slaves.

SYNOPSIS
Usage: pt-slave-find [OPTIONS] [DSN]

pt-slave-find finds and prints a hierarchy tree of MySQL slaves.

Examples:

   pt-slave-find --host master-host

RISKS
Percona Toolkit is mature, proven in the real world, and well tested, but all database tools can pose a risk to the system and the database server. Before using this tool, please:

•   Read the tool's documentation

•   Review the tool's known "BUGS"

•   Test the tool on a non-production server

•   Backup your production server and verify the backups

DESCRIPTION
pt-slave-find connects to a MySQL replication master and finds its slaves. Currently the only thing it can do is print a tree-like view of the replication hierarchy.

The master host can be specified using one of two methods. The first method is to use the standard connection-related command line options: "--defaults-file", "--password", "--host", "--port", "--socket" or "--user".

The second method to specify the master host is a DSN. A DSN is a special syntax that can be either just a hostname (like "server.domain.com" or 1.2.3.4), or a "key=value,key=value" string. Keys are a single letter:

   KEY MEANING
   === =======
   h   Connect to host
   P   Port number to use for connection
   S   Socket file to use for connection
   u   User for login if not current user
   p   Password to use when connecting
   F   Only read default options from the given file

"pt-slave-find" reads all normal MySQL option files, such as ~/.my.cnf, so you may not need to specify username, password and other common options at all.

EXIT STATUS
An exit status of 0 (sometimes also called a return value or return code) indicates success. Any other value represents the exit status of the Perl process itself.

OPTIONS
This tool accepts additional command-line arguments. Refer to the "SYNOPSIS" and usage information for details.

--ask-pass
    Prompt for a password when connecting to MySQL.

--charset
    short form: -A; type: string

    Default character set. If the value is utf8, sets Perl's binmode on STDOUT to utf8, passes the mysql_enable_utf8 option to DBD::mysql, and runs SET NAMES UTF8 after connecting to MySQL. Any other value sets binmode on STDOUT without the utf8 layer, and runs SET NAMES after connecting to MySQL.

--config
    type: Array

    Read this comma-separated list of config files; if specified, this must be the first option on the command line.

--database
    type: string; short form: -D

    Database to use.

--defaults-file
    short form: -F; type: string

    Only read mysql options from the given file. You must give an absolute pathname.

--help
    Show help and exit.

--host
    short form: -h; type: string

    Connect to host.

--password
    short form: -p; type: string

    Password to use when connecting. If password contains commas they must be escaped with a backslash: "exam\,ple"

--pid
    type: string

    Create the given PID file. The tool won't start if the PID file already exists and the PID it contains is different than the current PID. However, if the PID file exists and the PID it contains is no longer running, the tool will overwrite the PID file with the current PID. The PID file is removed automatically when the tool exits.

--port
    short form: -P; type: int

    Port number to use for connection.

--recurse
    type: int

    Number of levels to recurse in the hierarchy. Default is infinite.

    See "--recursion-method".

--recursion-method
    type: array; default: processlist,hosts

    Preferred recursion method used to find slaves.

    Possible methods are:

      METHOD       USES
      ===========  ==================
      processlist  SHOW PROCESSLIST
      hosts        SHOW SLAVE HOSTS
      none         Do not find slaves

    The processlist method is preferred because SHOW SLAVE HOSTS is not reliable. However, the hosts method is required if the server uses a non-standard port (not 3306). Usually pt-slave-find does the right thing and finds the slaves, but you may give a preferred method and it will be used first. If it doesn't find any slaves, the other methods will be tried.

--report-format
    type: string; default: summary

    Set what information about the slaves is printed. The report format can be one of the following:

    •   hostname

        Print just the hostname name of the slaves. It looks like:

          127.0.0.1:12345
          +- 127.0.0.1:12346
             +- 127.0.0.1:12347

    •   summary

        Print a summary of each slave's settings. This report shows more information about each slave, like:

          127.0.0.1:12345
          Version         5.1.34-log
          Server ID       12345
          Uptime          04:56 (started 2010-06-17T11:21:22)
          Replication     Is not a slave, has 1 slaves connected
          Filters
          Binary logging  STATEMENT
          Slave status
          Slave mode      STRICT
          Auto-increment  increment 1, offset 1
          +- 127.0.0.1:12346
             Version         5.1.34-log
             Server ID       12346
             Uptime          04:54 (started 2010-06-17T11:21:24)
             Replication     Is a slave, has 1 slaves connected
             Filters
             Binary logging  STATEMENT
             Slave status    0 seconds behind, running, no errors
             Slave mode      STRICT
             Auto-increment  increment 1, offset 1

--resolve-address
    Resolve ip-address to hostname. Report will print both IP and hostname.

    Example:

       10.10.7.14 (dbase1.sample.net)

    Might delay runtime a few seconds.

--slave-user
    type: string

    Sets the user to be used to connect to the slaves. This parameter allows you to have a different user with less privileges on the slaves but that user must exist on all slaves.

--slave-password
    type: string

    Sets the password to be used to connect to the slaves. It can be used with --slave-user and the password for the user must be the same on all slaves.

--set-vars
    type: Array

    Set the MySQL variables in this comma-separated list of "variable=value" pairs.

    By default, the tool sets:

       wait_timeout=10000

    Variables specified on the command line override these defaults. For example, specifying "--set-vars wait_timeout=500" overrides the defaultvalue of 10000.

    The tool prints a warning and continues if a variable cannot be set.

--socket
    short form: -S; type: string

    Socket file to use for connection.

--user
    short form: -u; type: string

    User for login if not current user.

--version
    Show version and exit.

DSN OPTIONS
These DSN options are used to create a DSN. Each option is given like "option=value". The options are case-sensitive, so P and p are not the same option. There cannot be whitespace before or after the "=" and if the value contains whitespace it must be quoted. DSN options are comma-separated. See the percona-toolkit manpage for full details.

•   A

    dsn: charset; copy: yes

    Default character set.

•   D

    dsn: database; copy: yes

    Default database.

•   F

    dsn: mysql_read_default_file; copy: yes

    Only read default options from the given file

•   h

    dsn: host; copy: yes

    Connect to host.

•   p

    dsn: password; copy: yes

    Password to use when connecting. If password contains commas they must be escaped with a backslash: "exam\,ple"

•   P

    dsn: port; copy: yes

    Port number to use for connection.

•   S

    dsn: mysql_socket; copy: yes

    Socket file to use for connection.

•   u

    dsn: user; copy: yes

    User for login if not current user.

ENVIRONMENT
The environment variable "PTDEBUG" enables verbose debugging output to STDERR. To enable debugging and capture all output to a file, run the tool like:

   PTDEBUG=1 pt-slave-find ... > FILE 2>&1

Be careful: debugging output is voluminous and can generate several megabytes of output.

SYSTEM REQUIREMENTS
You need Perl, DBI, DBD::mysql, and some core packages that ought to be installed in any reasonably new version of Perl.

BUGS
For a list of known bugs, see <http://www.percona.com/bugs/pt-slave-find>.

Please report bugs at <https://bugs.launchpad.net/percona-toolkit>. Include the following information in your bug report:

•   Complete command-line used to run the tool

•   Tool "--version"

•   MySQL version of all servers involved

•   Output from the tool including STDERR

•   Input files (log/dump/config files, etc.)

If possible, include debugging output by running the tool with "PTDEBUG"; see "ENVIRONMENT".

DOWNLOADING
Visit <http://www.percona.com/software/percona-toolkit/> to download the latest release of Percona Toolkit. Or, get the latest release from the command line:

   wget percona.com/get/percona-toolkit.tar.gz

   wget percona.com/get/percona-toolkit.rpm

   wget percona.com/get/percona-toolkit.deb

You can also get individual tools from the latest release:

   wget percona.com/get/TOOL

Replace "TOOL" with the name of any tool.

AUTHORS
Baron Schwartz and Daniel Nichter

ABOUT PERCONA TOOLKIT
This tool is part of Percona Toolkit, a collection of advanced command-line tools for MySQL developed by Percona. Percona Toolkit was forked from two projects in June, 2011: Maatkit and Aspersa. Those projects were created by Baron Schwartz and primarily developed by him and Daniel Nichter. Visit <http://www.percona.com/software/> to learn about other free, open-source software from Percona.

COPYRIGHT, LICENSE, AND WARRANTY
This program is copyright 2011-2017 Percona LLC and/or its affiliates, 2007-2011 Baron Schwartz.

THIS PROGRAM IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation, version 2; OR the Perl Artistic License. On UNIX and similar systems, you can issue `man perlgpl' or `man perlartistic' to read these licenses.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.

VERSION
pt-slave-find 3.0.6